<?php

defined('BASEPATH') OR exit('No direct script access allowed');

/* Copyright (C) Hawks Solutions  - All Rights Reserved 
 * 
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * 
 * Proprietary and confidential 
 * 
 * Written by Anuraj <anurajpr2266@gmail.com>, November 2017  */

class Uploads extends AdminController {

    public function __construct() {
        parent::__construct();
        $this->load->model("Upload");
        $this->load->model('ContentType');
        // $this->load->model('Benefits');
    }

    public function index() {
       
        // $data['images'] = $this->Upload->getImagesByDate(date('Y-m-d'));
        // $data['images'] = $this->Upload->getAllImages();
        $data['today'] = date('Y-m-d');
        $data['image_types'] = $this->Upload->getAllImageTypes();
        $this->load->view('admin/layouts/header', $data);
        $this->load->view('admin/uploads', $data);
        $this->load->view('admin/layouts/footer');
    }

    /*
     * Function used for uploading image
     * 
     * @param null
     * 
     * @return boolean
     */

    public function do_upload() {
        $config['upload_path'] = './assets/images/uploads/';
        $config['allowed_types'] = 'gif|jpg|png|pdf|jpeg';
        $config['max_size'] = 2048;
        $config['max_width'] = 0;
        $config['max_height'] = 0;
        $new_name = time();
        $config['file_name'] = $new_name;
        $this->load->library('upload', $config);
        if (!$this->upload->do_upload('file')) {
            $error = array('error' => $this->upload->display_errors());
            print_r($error);
            return false;
            die;
        } else {            
            $data = array('upload_data' => $this->upload->data());            
            $data['upload_data']['path'] = "assets/images/uploads/" . $data['upload_data']['file_name'];
            ///////////////////////Image resize///////////////////////////////////////
            $config['image_library'] = 'gd2';
            $config['source_image'] = './assets/images/uploads/' . $data['upload_data']['file_name']; //$data['upload_data']['full_path'];
            $config['create_thumb'] = TRUE;
//            $config['maintain_ratio'] = TRUE;
            $config['width'] = 240;
            $config['height'] = 161;
            $config['new_image'] = './assets/images/uploads/thumbnails/' . $data['upload_data']['file_name'];
            $this->load->library('image_lib', $config);
            $this->image_lib->initialize($config);
          //  if($data['upload_data']['file_ext']!=".pdf"){
            // if (!$this->image_lib->resize()) {
            //     echo $this->image_lib->display_errors();
            //     die;
            // }
          //  }
            
            $data['upload_data']['thumb_path'] = 'assets/images/uploads/thumbnails/' . $data['upload_data']['raw_name'] . '_thumb' . $data['upload_data']['file_ext'];
            /////////////////////////End////////////////////////////////////            
//          Save data to database 
            $imgId=$this->Upload->insertOrUpdateUploadData($data);
            //    for inserting table logs..
                    $userId=$this->session->userdata('siteData');
                    $logdata = array(
                        'username' => $userId[0]['username'],
                        'contentId' => 0,
                        'imgId'=>$imgId,
                        'description'=>$userId[0]['username'].''.' added a image',
                    );
                    $this->Common->insertLogs($logdata);
                   // logs table insertion ends here
//          End
            print_r($data);
            return true;
            die;
        }
    }

    /*
     * Function for controlling ajax
     * 
     * @param null
     * 
     * @return json
     */

    public function ajax() {
        $data = $this->input->post();
        $action = $data["action"];
        switch ($action) {
            case 'getImages':
                echo json_encode($this->Upload->getAllImages());
                break;
            case 'getImagesByDate':
                $currentDate = $data['currentDate'];
                if ($currentDate == "undefined" || !$this->Common->validateDate($currentDate)) {
                    $currentDate = date('Y-m-d');
                }
                echo $this->Upload->getImagesByDate($currentDate);
                break;
            case 'getImagesById':
            if(!empty($data['imageId']))
                $imageId = $data['imageId'];
            else
                $imageId=0;
                return $this->getImagesById($imageId);
                break;
            case 'saveImageProperties':
                return $this->saveImageProperties($data);
                break;
            case 'removeImage':
                $imageId = $data['imageId'];
                return $this->removeImage($imageId);
                break;
            case 'removeImages':
                return $this->removeImages($data);
                break;
            case 'change_status':
                return $this->changeImageStatus($data);
                break;
            case 'change_status_multi':
                return $this->changeImageStatusMulti($data);
                break;
            case 'assignto':
                return $this->assignTo($data);
                break;
            case 'getSubcontents':
                return $this->getSubcontents($data);
                break;
            case 'getProducts':
                return $this->getProducts();
                break;
            case 'saveProductOrBenefitImage':
                return $this->saveProductOrBenefitImage($data);
                break;
            case 'getBenefits':
                return $this->getBenefits($data);
                break;
            default:
                break;
        }
    }

    /* fn to get information of a particular image.
     * argument is image-id.
     */

    private function getImagesById($imgId) {
        if (!empty($imgId)) {
            $imgInfo = $this->Upload->getImageById($imgId);
            $images= $this->Upload->getAllImages();
            $contentTypes = $this->ContentType->getContentWithImage();
            if ($contentTypes) {
                $contents = [];
                foreach ($contentTypes as $content) {
                    if ($content->haveMultpleImg == 1) {
                        $cntnts = $this->Common->getContent($content->id);
                        if ($cntnts) {
                            $contents[$content->id] = $cntnts;
                        }
                    }
                }
            } else {
                $contentTypes = [];
                $contents = [];
            }
            if (!empty($imgInfo)) {
                $data = array(
                    'success' => true,
                    'imageInfo' => $imgInfo,
                    'contentTypes' => $contentTypes,
                    'contents' => $contents,
                    'images'=>$images
                );
                echo json_encode($data);
            }
        }else{
              $contentTypes = $this->ContentType->getContentWithMultipleImage();
               $images= $this->Upload->getAllImages();
            if ($contentTypes) {
                $contents = [];
                foreach ($contentTypes as $content) {
                    if ($content->haveMultpleImg == 1) {
                        $cntnts = $this->Common->getContent($content->id);
                        if ($cntnts) {
                            $contents[$content->id] = $cntnts;
                        }
                    }
                }
            } else {
                $contentTypes = [];
                $contents = [];
            }
             $data = array(
                    'success' => true,
                    'contentTypes' => $contentTypes,
                    'contents' => $contents,
                    'images'=>$images
                );
                echo json_encode($data);
        }
    }

    /* fn to update the image properties.
     * param contains image properties such as caption,description and type.
     */

    private function saveImageProperties($data) {
        if (!empty($data)) {

            $check = $this->ContentType->get($data['type']);
            if (!empty($check)) {

                if (($check->height == $data['height'] && $check->width == $data['width']) || ($check->height == 0 && $check->width == 0)) {

                    $upload = array(
                        'caption' => $data['caption'],
                        'description' => $data['description'],
                        'contentTypeId' => $data['type'],
                        'contentId' => $data['subType'],
                         
                    );
                    //checking for reduntant image in case single image content type.
                    // if ($check->haveMultpleImg == 0) {
                    //     $checkData = $this->Upload->getImagebyType($data['type']);
                    //     if (!empty($checkData)) {
                    //         if (unlink($checkData[0]['path']) && unlink($checkData[0]['thumb_path'])) {
                    //             $this->Upload->delete($checkData[0]['id']);
                    //         }
                    //     }
                    // }
                     
                    //
                    if ($this->Upload->save($upload, $data['imageId'])) {
                        $resultant = array(
                            'success' => true,
                        );
                        echo json_encode($resultant);
                    }
                } else {
                    $resultant = array(
                        'success' => false,
                        'imageType' => $check->content_type,
                        'height' => $check->height,
                        'width' => $check->width,
                    );
                    echo json_encode($resultant);
                }
            } else if ($data['caption'] != "" || $data['description'] != "") {
                $upload = array(
                    'caption' => $data['caption'],
                    'description' => $data['description'],
                );
                if ($this->Upload->save($upload, $data['imageId'])) {
                    $resultant = array(
                        'success' => true,
                    );
                    echo json_encode($resultant);
                }
            } else {
                $resultant = array(
                    'selection' => false,
                );
                echo json_encode($resultant);
            }
        }
    }

    /*
     * fn to remove image from table and unlink from folder.
     * param is imageId.
     */

    private function removeImage($imgId) {
        if (!empty($imgId)) {
            $image = $this->Upload->get($imgId);
            if (!empty($image)) {
                if (unlink($image->path) && unlink($image->thumb_path)) {
                    if ($this->Upload->delete($imgId)) {
                       
                        //    for inserting table logs..
                        $userId = $this->session->userdata('siteData');
                        $logdata = array(
                            'username' => $userId[0]['username'],
                            'contentId' => 0,
                            'imgId' => $imgId,
                            'description' => $userId[0]['username'] . '' . ' deleted a image',
                        );
                        $this->Common->insertLogs($logdata);
                        // logs table insertion ends here


                        $data = array(
                            'success' => true,
                        );
                        echo json_encode($data);
                    }
                }
            }
        }
    }

    /*
     * fn to remove multiple image from table and unlink from folder.
     * param is imageIds.
     */

    private function removeImages($data) {
        if (!empty($data)) {
            // $this->db->where_in('id', $data['multiimages']);
            // $this->db->delete('uploads');
            $dltflag=0;
            foreach ($data['multiimages'] as $imgId){   
            $image = $this->Upload->get($imgId);
            if (!empty($image)) {
                if (unlink($image->path) && unlink($image->thumb_path)) {
                    if ($this->Upload->delete($imgId)) {
                       
                        //    for inserting table logs..
                        $userId = $this->session->userdata('siteData');
                        $logdata = array(
                            'username' => $userId[0]['username'],
                            'contentId' => 0,
                            'imgId' => $imgId,
                            'description' => $userId[0]['username'] . '' . ' deleted a image',
                        );
                        $this->Common->insertLogs($logdata);
                        // logs table insertion ends here
                        $dltflag=1;

                    }else{
                       $dltflag=0;
                       break;
                    }
                }else{
                   $dltflag=0;
                       break;
                }
            }else{
                    $dltflag=0;
                       break;
                }
            }
                    if($dltflag==0){
                        $data = array(
                            'success' => false,
                        );
                    }else{
                        $data = array(
                            'success' => true,
                        );
                    }
                       
                        echo json_encode($data);
        }
    }

    /*
     * fn to change the status of the image
     */

    private function changeImageStatus($data) {
//        var_dump($data);die;
        if (!empty($data)) {
            $upload = array(
                'status' => $data['status'],
            );
            if ($this->Upload->save($upload, $data['imageId'])) {
                
                
                //    for inserting table logs..
                $userId = $this->session->userdata('siteData');
                $logdata = array(
                    'username' => $userId[0]['username'],
                    'contentId' => 0,
                    'imgId' => $data['imageId'],
                    'description' => $userId[0]['username'] . '' . ' changed image status',
                );
                $this->Common->insertLogs($logdata);
                // logs table insertion ends here
                
                $result = array(
                    'success' => true,
                    'status' => $data['status'],
                );
                echo json_encode($result);
            }
        }
    }
    /*
     * fn to assign images to type
     */

    private function assignTo($data) {
//        var_dump($data);die;
        if (!empty($data)) {
            $assignbit=0;
            $assign=$data['assign'];
            // $assignid=$this->ContentType->getId("content_type",$assign);
            foreach ($data['multiimages'] as $imgId){  

                $data_save=array(
                    // 'contentTypeId'=>$assignid,
                    'contentTypeId'=>$assign,
                );
             if ($this->Upload->save($data_save, $imgId)) {
                
                
                //    for inserting table logs..
                $userId = $this->session->userdata('siteData');
                $logdata = array(
                    'username' => $userId[0]['username'],
                    'contentId' => 0,
                    'imgId' => $imgId,
                    'description' => $userId[0]['username'] . '' . ' changed image status',
                );
                $this->Common->insertLogs($logdata);
                // logs table insertion ends here
                $assignbit=1;
               
            }else{
                $assignbit=0;
            }
        }

                    if($assignbit==0){
                        $data = array(
                            'success' => false,
                        );
                    }else{
                        $data = array(
                            'success' => true,
                        );
                    }
                echo json_encode($data);
        }
    }
    /*
     * fn to change the status of the multiple images
     */

    private function changeImageStatusMulti($data) {
//        var_dump($data);die;
        if (!empty($data)) {
            $statusbit=0;
            $status=$data['status'];
            foreach ($data['multiimages'] as $imgId){  

                $data_save=array(
                    'status'=>$status,
                );
             if ($this->Upload->save($data_save, $imgId)) {
                
                
                //    for inserting table logs..
                $userId = $this->session->userdata('siteData');
                $logdata = array(
                    'username' => $userId[0]['username'],
                    'contentId' => 0,
                    'imgId' => $imgId,
                    'description' => $userId[0]['username'] . '' . ' changed image status',
                );
                $this->Common->insertLogs($logdata);
                // logs table insertion ends here
                $statusbit=1;
               
            }else{
                $statusbit=0;
            }
        }

                    if($statusbit==0){
                        $data = array(
                            'success' => false,
                        );
                    }else{
                        $data = array(
                            'success' => true,
                        );
                    }
                echo json_encode($data);
        }
    }
/*
* fn to get subcontents of a content type
*/
private function getSubcontents($data){
    $subcontents=$this->Common->getContentForAssignByType($data['type']);
    if(!empty($subcontents)){
        $data = array(
                    'success' => true,
                    'subcontents' => $subcontents,
                );
                echo json_encode($data);
    }
}/*
* fn to select products to  a dropdown
*/
private function getProducts(){
    $products=$this->Products->getProductForUploads();
    if(!empty($products)){
        $data = array(
                    'success' => true,
                    'contents' => $products,
                );
                echo json_encode($data);
    }
}
/*
* Fn to get benefits of products
*/
private function getBenefits($data){
     $benefits=$this->Benefits->getAll();
     if(!empty($benefits)){
        $data = array(
                    'success' => true,
                    'contents' => $benefits,
                );
                echo json_encode($data);
    }
}
/*
* Fn to save product or Benefit Image
*/
private function saveProductOrBenefitImage($data){ 
    if(!empty($data)){ 
        $image=array(
            'productId'=>$data['subType'], 
            'imageId'=>$data['imageId'],
        );
        if($data['imagetype']==2){
            $product=array(
                'bgImage'=>$data['imageId'],
            );
            $id=$this->Products->save($product,$data['subType']);
            
        }
        else if($data['imagetype']==1){
            $product=array(
                'imageId'=>$data['imageId'],
            );
            $id=$this->Products->save($product,$data['subType']);
//            $id=$this->Productimages->save($image);
        }else if($data['imagetype']==4){
            $product=array(
                'openImage'=>$data['imageId'],
            );
            $id=$this->Products->save($product,$data['subType']);
        }else if($data['imagetype']==5){
            $product=array(
                'campusBoard'=>$data['imageId'],
            );
            $id=$this->Products->save($product,$data['subType']);
        }else if($data['imagetype']==6){
            $product=array(
                'tds'=>$data['imageId'],
            );
            $id=$this->Products->save($product,$data['subType']);
        }else if($data['imagetype']==7){
            $product=array(
                'packetImg'=>$data['imageId'],
            );
            $id=$this->Products->save($product,$data['subType']);
        }
        if( !empty($data['contentimage'])){
            $contenttypes=array(
            'image'=>$data['imageId'],
            );
            $id=$this->Types->save($contenttypes,$data['contentimage']);
        }
        else{
             
        if($data['type']==50 && $data['imagetype']==3){
            $id=$this->Productimages->save($image);
        }
        elseif($data['type']==51){
            $image=array( 
            'image'=>$data['imageId'],
        );
            $id=$this->Benefits->save($image,$data['benefitId']);
        }elseif($data['type']==53){
             $image=array(
            'image'=>$data['imageId'],
        );
            $id=$this->Works->save($image,$data['workId']);
        }
        
    }
    
        
        
        if($id>0){
            $result = array(
                    'success' => true,
                );
                echo json_encode($result);
        }
        
    }

}
}
