<?php
class ContentType extends MY_Model {
    protected $_table_name = 'content_types';
    protected $_primary_key = 'id';
    protected $_primary_filter = 'intval';
    protected $_order_by = 'position';
    protected $_rules = array();
    protected $_timestamps = false;   

    /*
     * fn to get content types that have image(s).
     * returns result set.
     */
    function getContentWithImage(){
        $query=$this->db->select('*')
                    ->from('content_types')
                    ->where('haveImg',1)
                    ->get();
        if(!empty($query)){
            return $query->result();
        }else{
            return false;
        }
    }
    /*
     * fn to get content types that have multiple image(s).
     * returns result set.
     */
    function getContentWithMultipleImage(){
        $query=$this->db->select('*')
                    ->from('content_types')
                    ->where('haveImg',1)
                    ->where('haveMultpleImg',1)
                    ->get();
        if(!empty($query)){
            return $query->result();
        }else{
            return false;
        }
    }

    function getAllTestimonials(){
        $query=$this->db->select('c.content,c.name,u.path as image')
                        ->from('content c')
                        ->join('uploads u','c.id=u.contentId','left')
                        ->where('c.content_type_id',54)
                        ->get();
         if(!empty($query)){
            return $query->result();
        }else{
            return false;
        }          
    }

    function getAllSliders(){
        $query=$this->db->select('c.content,c.name,c.place,u.path as image')
                        ->from('content c')
                        ->join('uploads u','u.contentTypeId=c.id','LEFT')
                        ->where('c.content_type_id',4)
                        ->get();
         if(!empty($query)){
            return $query->result();
        }else{
            return false;
        }       
    }

    function getAllGallery(){
        $query=$this->db->select('path as image,caption')
                        ->from('uploads ')
                        ->where('contentTypeId',1)
                        ->where('status','active')
                        ->get();
         if(!empty($query)){
            return $query->result();
        }else{
            return false;
        }       
    }

    function getAllVehicle(){
        $query=$this->db->select('path as image,caption')
                        ->from('uploads')
                        ->where('contentTypeId',7)
                        ->where('status','active')
                        ->get();
         if(!empty($query)){
            return $query->result();
        }else{
            return false;
        }       
    }
    
}