<?php

/**
 * @Author: Nighil George
 * @Date:   2017-12-01 16:00:57
 * @Last Modified by:   Nighil George
 * @Last Modified time: 2018-03-03 14:05:29
 */
?>
<style>
.switch {
  position: relative;
  display: inline-block;
  width: 51px;
  height: 27px;
}

.switch input {display:none;}

.slider {
  position: absolute;
  cursor: pointer;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: #ccc;
  -webkit-transition: .4s;
  transition: .4s;
}

.slider:before {
  position: absolute;
  content: "";
  height: 19px;
  width: 19px;
  left: 4px;
  bottom: 4px;
  background-color: white;
  -webkit-transition: .4s;
  transition: .4s;
}

input:checked + .slider {
  background-color: #2196F3;
}

input:focus + .slider {
  box-shadow: 0 0 1px #2196F3;
}

input:checked + .slider:before {
  -webkit-transform: translateX(26px);
  -ms-transform: translateX(26px);
  transform: translateX(26px);
}

/* Rounded sliders */
.slider.round {
  border-radius: 34px;
}

.slider.round:before {
  border-radius: 50%;
}
</style>
<div ng-app="adminApp" ng-controller="productController" id="productController" ng-init="clearForm()">
    <div class="row" >
        <div class="col-lg-12">
            <h1 class="page-header">Product</h1>
        </div>
    </div>
    <div class="row">
        <div class="col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    Form
                </div>
                <div class="panel-body">
                    <div class="row">
                        <div class="col-lg-12">
                            <form role="form" id="formProduct">
                            	 <div class="form-group">
                                    <label>Name</label>
                                    <input type="text" ng-model="productname" name="productname" class="form-control">
                                </div>
                                <div class="form-group">
                                    <label class="switch">
                                        <input type="checkbox" name="featured" ng-model="featured">
                                        <span class="slider round"></span>                                        
                                    </label>
                                    <label ng-if="featured==true;">Featured</label>
                                    <label ng-if="featured!=true;">Not-Featured</label>

                                    <!--                                    <label>Featured</label>
                                                                        <input type="checkbox" name="featured" ng-model="featured">-->
                                </div>
                            	<div class="form-group">
                                    <label>Category</label>
                                    <select class="form-control" ng-model="category" name="category" ng-change="ajaxChangeCategory()">
                                        <option value="">Select </option>
                                        <option ng-repeat="category in categories" value="{{category.id}}">
                                            {{category.category}} 
                                        </option>
                                    </select>
                                    <p class="help-block">Select a category</p>
                                </div> 
                                <div class="form-group">
                                    <label>Type</label>
                                    <select class="form-control" ng-model="type" name="type" ng-change="ajaxChangeType()">
                                        <option value="">Select </option>
                                        <option ng-repeat="type in types" value="{{type.id}}">
                                            {{type.type}} 
                                        </option>
                                    </select>
                                    <p class="help-block">Select a type</p>
                                </div> 
                                <div class="form-group" >
                                    <label>Description</label>
                                    <div id="editor" name="description" ng-model="description">                                        
                                    </div>
                                    <p class="help-block">Write description</p>
                                </div> 
                                <div class="form-group" >
                                    <label>Direction Of Use</label>
                                    <div id="editoruse" name="directionofuse" ng-model="directionofuse">                                        
                                    </div>
                                    <p class="help-block">Write direction of use</p>
                                </div> 
                                <div class="form-group">
                                    <label>Packet Size</label><br/>
                                    <div class="col-md-3" ng-repeat="packet in packets">
                                    <input type="checkbox" value="{{packet}}"  name="availablePackets[]" > {{packet}}
                                </div>
                                </div>
                                 
                                <div class="pull-right">
                                    <button type="submit" ng-click="save()" class="btn btn-success">Save</button>                                
                                </div>
               
                            </form>
                        </div>                       
                    </div>
                    <!-- /.row (nested) -->
                </div>
                <!-- /.panel-body -->
            </div>
            <!-- /.panel -->
        </div>
        <!-- /.col-lg-12 -->
        <!--================= table view start here ===================-->
    <table class="table">
        <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Product</th>
                <th scope="col">Category</th>
                <th scope="col">Type</th>
                <!-- <th scope="col">Description</th> -->
                <th scope="col">Edit</th>
                <th scope="col">Delete</th>
            </tr>
        </thead>
        <tbody>
            <tr ng-repeat="product in products">
                <th scope="row">{{$index+1}}</th>
                <td>{{product.name}}</td>
                <td>{{product.category}}</td>
                <td>{{product.type}}</td>

                <!-- <td>{{product.description}}</td> -->
               
                <!--Edit-->                               
                <td><i style="color: #0b8fca;font-size: 20px;" class="fa fa-pencil-square" aria-hidden="true" ng-click="openModal(product.id)"></i></td> <!--delete-->                               
                <td><i style="color: #ca0b0b;font-size: 20px;" class="fa fa-trash-o" aria-hidden="true" ng-click="confirmationMsg(product.id)"></i></td>
                <!--===============-->
            </tr>
        </tbody>
    </table>
    <!--================== table view end =========================-->
    </div>
    <input type="hidden" id="data-types" value="<?php echo htmlentities($types); ?>"/>
    <input type="hidden" id="data-categories" value="<?php echo htmlentities($categories); ?>"/>
    <input type="hidden" id="data-packets" value="<?php echo htmlentities($packets); ?>"/>

    <!-- Modal -->
    <div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header poup-head-color shadow">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span class="popup-close-btn" aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title text-center modal-head-title" id="myModalLabel">Product details</h4>
                </div>
                <div class="modal-body shadow">
                    <!--========= modal body start ===========-->
                    <div class="row modal-body-row">
                        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                            <form role="form" id="formProductEdit">
                            <div class="row">
                                <div class="form-group form-margin">
                                    <label class="col-md-4 control-label" for="name">Name</label>  
                                    <div class="col-md-8">
                                        <input id="textinput" ng-model="productname" id="productname" name="productname" type="text" value="{{productname}}" class="form-control input-md">
                                    </div>
                                </div>
                                <div class="form-group form-margin">
                                    <label class="col-md-4 control-label" for="category">Category</label>  
                                    <div class="col-md-8">
                                        <select class="form-control" id="productcategory" ng-model="productcategory" name="category" ng-change="ajaxChangeCategory()">
                                        <option value="">Select </option>
                                        <option ng-repeat="category in categories" value="{{category.id}}">
                                            {{category.category}} 
                                        </option>
                                    </select>
                                    </div>
                                </div>
                                <div class="form-group form-margin">
                                    <label class="col-md-4 control-label" for="type">Type</label>  
                                    <div class="col-md-8">
                                         <select class="form-control" id="producttype" ng-model="producttype" name="type" ng-change="ajaxChangeType()">
                                        <option value="">Select </option>
                                        <option ng-repeat="type in types" value="{{type.id}}">
                                            {{type.type}} 
                                        </option>
                                    </select>
                                    </div>
                                </div>
                                <div class="form-group form-margin2">
                                    <label class="col-md-4 control-label" for="textinput">Description</label>  
                                    <div class="col-md-8">
                                        <textarea class="form-control" id="productdescription" ng-model="productdescription" rows="3">{{description}}</textarea>
                                    </div>
                                </div>
                                <div class="form-group form-margin2">
                                    <label class="col-md-4 control-label" for="textinput">Direction Of Use</label>  
                                    <div class="col-md-8">
                                        <textarea class="form-control" id="directionofuse" ng-model="directionofuse" rows="3">{{direction}}</textarea>
                                    </div>
                                </div>
                                  
                                <div class="form-group">
                                    <label>Packet Size</label><br/>
                                    <div class="col-md-3" ng-repeat="packet in packets">
                                    <input type="checkbox" value="{{packet}}"  name="availablePackets[]" ng-checked="productPacketsSelected.indexOf(packet)>-1" > {{packet}}
                                </div>
                                </div>
                            </div>
                        </form>
                        </div>
                       
                    </div>
                    <!--======== modal body end ============-->
                </div>
                <div class="modal-footer  modal-footer-color shadow">
                    <button type="button" class="btn btn-save" ng-click="save()">Save</button>
                    <button type="button" class="btn btn-close" data-dismiss="modal">Close</button>

                </div>
            </div>
        </div>
    </div>
</div>
<!-- Custom angular  -->
<script src="<?php echo base_url('assets/js/angular/controller/productController.js'); ?>"></script> 

