<?php

$app->group('/v1', function () {

    /*     * *******************************
     * CommonAction routes starts here
     * ******************************* */
    $this->group('/pagination', function () {
        $this->POST('', 'App\Action\CommonAction:simplepaginate');
        $this->POST('/singlecondition', 'App\Action\CommonAction:singleConditionPagination');
    });
    $this->group('/sendMail', function () {
        $this->post('', 'App\Action\CommonAction:sendMail');
    });
    $this->group('/getDailyaudio', function () {
        $this->post('', 'App\Action\CommonAction:getDailyaudio');
    });
    $this->group('/getQuote', function () {
        $this->get('', 'App\Action\CommonAction:getQuote');
    });
    $this->group('/togglestatus', function () {
        $this->post('', 'App\Action\CommonAction:togglestatus');
    });
    $this->group('/togglestatusMulti', function () {
        $this->post('', 'App\Action\CommonAction:togglestatusMulti');
    });
    $this->group('/deleteimage', function () {
        $this->post('', 'App\Action\CommonAction:deleteimage');
    });
    $this->group('/softdelete', function () {
        $this->post('', 'App\Action\CommonAction:softdelete');
    });
    $this->group('/softdeleteMulti', function () {
        $this->post('', 'App\Action\CommonAction:softdeleteMulti');
    });
    $this->group('/getrow', function () {
        $this->post('', 'App\Action\CommonAction:getrow');
    });
    $this->group('/searchitem', function () {
        $this->post('', 'App\Action\CommonAction:searchItem');
    });
    $this->group('/common', function () {
        $this->post('/authenticate', 'App\Action\CommonAction:authenticateUser');
        $this->post('/getpassword', 'App\Action\CommonAction:getPassword');
        $this->post('/changepassword', 'App\Action\CommonAction:changePassword');
    });
    /*     * *******************************
     * CommonAction routes ends here 
     * ******************************* */

    /*     * *******************************
     * StoreAction routes starts here 
     * ******************************* */
    $this->group('/store', function () {
        $this->post('', 'App\Action\StoreAction:addNew');
        $this->get('/medicinemapping', 'App\Action\StoreAction:getlist');
        $this->post('/medicinemapping', 'App\Action\StoreAction:mapping');
        $this->group('/{id}', function () {
            $this->delete('', 'App\Action\StoreAction:deleteItem');
        });
        $this->group('/getbyId/{id}', function () {
            $this->get('', 'App\Action\StoreAction:getbyId');
        });
        $this->get('/searchbylocation', 'App\Action\StoreAction:searchStore_byLocation');
        $this->get('/getproductsbystore', 'App\Action\StoreAction:getProductsbyStore');
        $this->get('/nearbydoctors', 'App\Action\StoreAction:nearbyDoctors');
        $this->get('/dualsearch', 'App\Action\StoreAction:searchStore_dualcondition');
    });
    /*     * *******************************
     * StoreAction routes ends here 
     * ******************************* */

    /*     * *******************************
     * ManufactureAction routes starts here 
     * ******************************* */
     $this->group('/manufacturer', function () {
        $this->post('', 'App\Action\MasterAction:addNewManufacturer');
    });
    /*     * *******************************
     * ManufactureAction routes ends here 
     * ******************************* */

    /*     * *******************************
     * CategoryAction routes starts here 
     * ******************************* */
     $this->group('/category', function () {
        $this->post('', 'App\Action\MasterAction:addNewCategory');
        
    });
      /*     * *******************************
     * CategoryAction routes starts here 
     * ******************************* */
     $this->group('/content', function () {
        $this->post('/list', 'App\Action\MasterAction:getContents');
        $this->post('', 'App\Action\MasterAction:addNewContent');
        
    });
      /*     * *******************************
     * registration routes starts here 
     * ******************************* */
     $this->group('/Registration', function () {
         $this->post('/list', 'App\Action\MasterAction:getRegistration');
        $this->post('', 'App\Action\MasterAction:addNewRegistration');
        
    });
       /*     * *******************************
     * Booking routes starts here 
     * ******************************* */
     $this->group('/Booking', function () {
         $this->post('/list', 'App\Action\MasterAction:getBooking');
        $this->post('', 'App\Action\MasterAction:addNewBooking');
        
    });
     /*     * *******************************
     * registration routes starts here 
     * ******************************* */
     $this->group('/Meditation', function () {
         $this->post('/list', 'App\Action\MasterAction:getMeditation');
           $this->post('/type', 'App\Action\MasterAction:getMeditationbytype');
        $this->post('', 'App\Action\MasterAction:addNewMeditation');
        
    });
    /*     * *******************************
     * CategoryAction routes ends here 
     * ******************************* */

    /*     * *******************************
     * DoctorAction routes starts here
     * ******************************* */
    $this->group('/doctor', function () {
        $this->post('', 'App\Action\DoctorAction:addNew');
        $this->group('/{id}', function () {
            $this->delete('', 'App\Action\DoctorAction:deleteItem');
        });
    });
    /*     * *******************************
     * DoctorAction routes ends here 
     * ******************************* */

});



