<?php

/**
 * @Author: hawks
 * @Date:   2018-08-31 15:19:47
 * @Last Modified by:   Nighil George
 * @Last Modified time: 2019-03-11 13:56:52
 */

namespace App\Action;

use Slim\Views\Twig;
use Psr\Log\LoggerInterface;
use Slim\Http\Request;
use Slim\Http\Response;
use App\Model\Manufacturer;
use App\Model\Category;
use App\Model\Common;
use App\Model\Content;
use App\Model\Registration;
use App\Model\Meditation;
use App\Model\Booking;
use Execption;

final class MasterAction {

    private $view;
    private $logger;

    public function __construct(Twig $view, LoggerInterface $logger) {
        $this->view = $view;
        $this->logger = $logger;        
    }

    /*
     * @Function Add new manufacturer
     * @param $request ,$response
     * $retun json
     */

    public function addNewManufacturer(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        if (!empty($data["imageUrl"]) && !empty($data["thumbImage"])) {
            $bUrl = $request->getUri()->getBaseUrl();
            $imgName = date("Y-m-d-H:i:s") . ".jpg";
            $thumbName = date("Y-m-d-H:i:s") . "_thumb.jpg";
            $adsUrl = $_SERVER["DOCUMENT_ROOT"] . $request->getUri()->getBasePath();
            $folder = $adsUrl . "/manufacturers";
            $folder2 = $adsUrl . "/manufacturers/thumb";
            $common = new Common();
            $image = $common->base64_to_jpeg($data["imageUrl"], $imgName, $folder);
            $thumb = $common->base64_to_jpeg($data["thumbImage"], $thumbName, $folder2);
            // $image = $bUrl . "/manufacturers/" . $image;
            // $thumb = $bUrl . "/manufacturers/thumb/" . $thumb;
            $image = "/manufacturers/" . $image;
            $thumb = "/manufacturers/thumb/" . $thumb;

        } else {
            $image = "";
            $thumb = "";
        }
        if ($data["id"] == 0) {
            $manufacture = new Manufacturer();
        } else {
            $manufacture = Manufacturer::find($data["id"]);

            if (!empty($manufacture->image) && !empty($image)) {
                print_r("unlink main");
                unlink($manufacture->image);
            } else {
                if (empty($image)) {
                    $image = $manufacture->image;
                }
            }
            if (!empty($manufacture->thumb) && !empty($thumb)) {
                print_r("unlink thumb");
                unlink($manufacture->thumb);
            } else {
                if (empty($thumb)) {
                    $thumb = $manufacture->thumb;
                }
            }
        }
        $manufacture->name = $data["manufacture"];
        $manufacture->status = $data["status"];
        $manufacture->image = $image;
        $manufacture->thumb = $thumb;
       if ($manufacture->save()) {
          
            $success = true;
        } else {
            $success = false;
        }
        return $response->withStatus(200)->getBody()->write(Json_encode(array("status" => $success)));
    }
    /*
     * @Function Add new Category
     * @param $request ,$response
     * $retun json
     */

    public function addNewCategory(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        if (!empty($data["imageUrl"]) && !empty($data["thumbImage"])) {
            $bUrl = $request->getUri()->getBaseUrl();
            $imgName = date("Y-m-d-H:i:s") . ".jpg";
            $thumbName = date("Y-m-d-H:i:s") . "_thumb.jpg";
            $adsUrl = $_SERVER["DOCUMENT_ROOT"] . $request->getUri()->getBasePath();
            $folder = $adsUrl . "/categories";
            $folder2 = $adsUrl . "/categories/thumb";
            $common = new Common();
            $image = $common->base64_to_jpeg($data["imageUrl"], $imgName, $folder);
            $thumb = $common->base64_to_jpeg($data["thumbImage"], $thumbName, $folder2);
            $image = "/categories/" . $image;
            $thumb = "/categories/thumb/" . $thumb;

        } else {
            $image = "";
            $thumb = "";
        }
        if ($data["id"] == 0) {
            $category = new Category();
        } else {
            $category = Category::find($data["id"]);

            if (!empty($category->image) && !empty($image)) {
                print_r("unlink main");
                unlink($category->image);
            } else {
                if (empty($image)) {
                    $image = $category->image;
                }
            }
            if (!empty($category->thumb) && !empty($thumb)) {
                print_r("unlink thumb");
                unlink($category->thumb);
            } else {
                if (empty($thumb)) {
                    $thumb = $category->thumb;
                }
            }
        }
        $category->name = $data["category"];
        $category->status = $data["status"];
        $category->description = $data["content"];
        $category->image = $image;
        $category->thumb = $thumb;
        $category->parent=$data["parent"];
        $category->sort_order=$data["sortorder"];
        if($data["topmenu"]=="on")
            $category->is_top_menu=1;
        else
            $category->is_top_menu=0;
        $category->metatitle=$data["metatitle"];
        $category->metakeywords=$data["metakeywords"];
        $category->metadescription=$data["metadescription"];
        if(!empty($data["parent"])&&$data["parent"]!=""){
        $parentInfo=Category::find($data["parent"]);
        if(!empty($parentInfo)){
                $category->ancestors=$parentInfo->ancestors ? $parentInfo->ancestors.",".$data["parent"] : $data["parent"];
                $category->path=$parentInfo->path ? $parentInfo->path."->".$parentInfo->name : $parentInfo->name;
            }else{
                $category->ancestors="";
                $category->path="";
                }
        }else{
            $category->ancestors="";
            $category->path="";
        }
       if ($category->save()){       	  
            $success = true;
        } else {
            $success = false;
        }
        return $response->withStatus(200)->getBody()->write(Json_encode(array("status" => $success)));
    }

    public function getContents(Request $request, Response $response, $args) {
        $data=$request->getParsedBody();
        $content=new Content();
        $total = count($content->entireData());
        $pageData = $content->pageData($data["pageLimit"],$data["offset"]);
        $lastPage = ceil($total / $data["pageLimit"]);
        $pagination = array(
            "currentPage" => $data["offset"] + 1,
            "pageData" => $pageData,
            "total" => $total,
            "lastPage" => $lastPage
        );
        return $response->withStatus(200)->getBody()->write(Json_encode(array("pagination" => $pagination)));

    }
     public function getRegistration(Request $request, Response $response, $args) {
        $data=$request->getParsedBody();
        $Common=new Common();
         $data["table"]="registration";
        $total = count($Common->entireData($data["table"]));
        $pageData = $Common->pageData($data["table"],$data["offset"],$data["pageLimit"]);
        $lastPage = ceil($total / $data["pageLimit"]);
        $pagination = array(
            "currentPage" => $data["offset"] + 1,
            "pageData" => $pageData,
            "total" => $total,
            "lastPage" => $lastPage
        );
        return $response->withStatus(200)->getBody()->write(Json_encode(array("pagination" => $pagination)));

    }

     public function getMeditation(Request $request, Response $response, $args) {
        $data=$request->getParsedBody();
        $Common=new Common();
         $data["table"]="meditation";
        $total = count($Common->entireData($data["table"]));
        $pageData = $Common->pageData($data["table"],$data["offset"],$data["pageLimit"]);
        $lastPage = ceil($total / $data["pageLimit"]);
        $pagination = array(
            "currentPage" => $data["offset"] + 1,
            "pageData" => $pageData,
            "total" => $total,
            "lastPage" => $lastPage
        );
        return $response->withStatus(200)->getBody()->write(Json_encode(array("pagination" => $pagination)));

    }
    public function addNewContent(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        if (!empty($data["imageUrl"]) ) {
            $bUrl = $request->getUri()->getBaseUrl();
            $imgName = date("Y-m-d-H:i:s") . ".jpg";
            // $thumbName = date("Y-m-d-H:i:s") . "_thumb.jpg";
            $adsUrl = $_SERVER["DOCUMENT_ROOT"] . $request->getUri()->getBasePath();
            $folder = $adsUrl . "/content";
            // $folder2 = $adsUrl . "/content/thumb";
            $common = new Common();
            $image = $common->base64_to_jpeg($data["imageUrl"], $imgName, $folder);
            // $thumb = $common->base64_to_jpeg($data["thumbImage"], $thumbName, $folder2);
            $image = "/content/" . $image;
            // $thumb = "/content/thumb/" . $thumb;

        } else {
            $image = "";
            // $thumb = "";
        }
        if ($data["id"] == 0) {
            $content = new Content();
        } else {
            $content = Content::find($data["id"]);

            if (!empty($content->media) && !empty($media)) {
                print_r("unlink main");
                unlink($content->media);
            } else {
                if (empty($image)) {
                    $image = $content->media;
                }
            }
        }
        $content->name_english= $data["name_english"];
        $content->name_malayalam= $data["name_malayalam"];
        $content->name_arabic= $data["name_arabic"];
        $content->content_english = $data["content_english"];
        $content->content_malayalam = $data["content_malayalam"];
        $content->content_arabic = $data["content_arabic"];
        $content->media = $image;
       
       if($data["endDate"]!=""){
        $end_date = $data["endDate"];
       } else{
            $end_date=null;
        }
        if($data["price"]!=""){
            $price=$data["price"];
        }else{
            $price="0";
        }
        if($data["benefits"]!=""){
        $benefits = $data["benefits"];
       } else{
            $benefits="0";
        } 
        if($data["guidelines"]!=""){
        $guidelines = $data["guidelines"];
       } else{
            $guidelines="0";
        }
        $content->price = $price;
         $content->end_date = $end_date;
        $content->content_type_id = $data["content_type_id"];
        $content->benefits = $benefits;
        $content->guidelines =$guidelines;


        if(!empty($data["topmenu"]))
        {
             $content->media = $data["mediavideo"];
            $content->imageOrVideo = 1;
        }

        else
        {
            $content->imageOrVideo = 2;
        }
          // return $response->withStatus(200)->getBody()->write(Json_encode(array("status" => $content)));
        
       if ($content->save()){            
            $success = true;
        } else {
            $success = false;
        }
        return $response->withStatus(200)->getBody()->write(Json_encode(array("status" => $success)));
    } 




 public function addNewMeditation(Request $request, Response $response, $args) {
    try{
        $data = $request->getParsedBody();

        if (!empty($data["imageUrl"]) ) {
            $bUrl = $request->getUri()->getBaseUrl();
            $imgName = date("Y-m-d-H:i:s") . ".mp3";
            // $thumbName = date("Y-m-d-H:i:s") . "_thumb.jpg";
            $adsUrl = $_SERVER["DOCUMENT_ROOT"] . $request->getUri()->getBasePath();
            $folder = $adsUrl . "/meditation";
            // $folder2 = $adsUrl . "/content/thumb";
            $common = new Common();
            $image = $common->base64_to_jpeg($data["imageUrl"], $imgName, $folder);
            // $thumb = $common->base64_to_jpeg($data["thumbImage"], $thumbName, $folder2);
            $image = "/meditation/" . $image;
            // $thumb = "/content/thumb/" . $thumb;

        } else {
            $image = "";
            // $thumb = "";
        }
        if ($data["id"] == 0) {
            $meditation = new Meditation();
        } else {
            $meditation = Meditation::find($data["id"]);

            if (!empty($meditation->media) && !empty($media)) {
                print_r("unlink main");
                unlink($meditation->media);
            } else {
                if (empty($image)) {
                    $image = $meditation->media;
                }
            }
        }
        $meditation->date= $data["Date"];
        $meditation->type= $data["type"];
      
        $meditation->media = $image;
       
      
       if ($meditation->save()){            
            $success = true;
        } else {
            $success = false;
        }
        return $response->withStatus(200)->getBody()->write(Json_encode(array("status" => $success)));

        }catch(Execption $ex){
             echo "Message: " .$e->getMessage();
        }
    } 

/*
 * @Function Add new registration
     * @param $request ,$response
     * $retun json
*/


     public function addNewRegistration(Request $request, Response $response, $args) {
        try{
              $data = $request->getParsedBody();    
// var_dump($data);exit;
        // if ($data["id"] == 0) {
            $registration = new Registration();
        // } else {
        //     $registration = Registration::find($data["id"]);

        // }
        
            $registration->name= $data["name"];
            $registration->mobile= $data["mobile"];
            $registration->email = $data["newemail"];
            $registration->name_english = $data["contentname"];
            $registration->content_id = $data["id"];
            $registration->price = $data["contentprice"];

       if ($registration->save()){            
            $success = true;
        } else {
            $success = false;
        }
        return $response->withStatus(200)->getBody()->write(Json_encode(array("status" => $success)));

        }catch(Execption $ex){
             echo "Message: " .$e->getMessage();
        }
   
      
    }/*
 * @Function Add new registration
     * @param $request ,$response
     * $retun json
*/


     public function addNewBooking(Request $request, Response $response, $args) {
        try{
              $data = $request->getParsedBody();    
// var_dump($data);exit;
        // if ($data["id"] == 0) {
            $booking= new Booking();
        // } else {
        //     $registration = Registration::find($data["id"]);

        // }
        
            $booking->name= $data["name"];
            $booking->mobile= $data["mobile"];
            $booking->email = $data["newemail"];
            $booking->english_name = $data["contentname"];
            $booking->contentId = $data["id"];
            $booking->price = $data["contentprice"];
  // return $response->withStatus(200)->getBody()->write(Json_encode(array("status" => $booking)));
       if ($booking->save()){            
            $success = true;
        } else {
            $success = false;
        }
        return $response->withStatus(200)->getBody()->write(Json_encode(array("status" => $success)));

        }catch(Execption $ex){
             echo "Message: " .$e->getMessage();
        }
   
      
    }
     /*
     * fn to search an item in a table
     */

    public function getMeditationbytype(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        // $connector=$data["connector"];
        $fields=$data["field"];
        $operator=$data["operator"];
        $value=$data["searchvalue"];
        $conditions=[];
        for ($i=0;$i<count($fields);$i++) {
            if($operator=="like"){
                $condition=array($fields[$i],$operator,"%".$value."%");
            }else{
                $condition=array($fields[$i],$operator,$value);
            }
                array_push($conditions, $condition);
            }        

        $total = count($commonObj->entireDatawithCondition($data["table"],$conditions));
        $pageData = $commonObj->pageDatawithCondition($data["table"], $data["offset"], $data["pageLimit"],$conditions);
        $lastPage = ceil($total / $data["pageLimit"]);
        $pagination = array(
            "currentPage" => $data["offset"] + 1,
            "pageData" => $pageData,
            "total" => $total,
            "lastPage" => $lastPage
        );
        return $response->withStatus(200)->getBody()->write(Json_encode(array("pagination" => $pagination)));
    }

}