<?php

/**
 * Hawks Solutions 
 * 
 * All right are reserved under copyright law.for further queries <hawkssolution@gmail.com>
 * 
 * Description of Common model
 *
 * @author Anuraj <anurajpr2266@gmail.com> ,
 */

namespace App\Model;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Capsule\Manager as DB;

class Common extends Model {

    /*
     * Function authenticate User
     * 
     * @param $request ,$response
     * 
     * @$retun json
     */

    public function authenticateUser($data = null) {
        if (!empty($data)) {
            if (isset($data['username']) && isset($data['password'])) {
                $user = DB::table('auth')->where('username', $data['username'])->where('password', $data['password'])->get();
                if (count($user) == 0) {
                    return json_encode(array('error' => 'username or password is incorrect'));
                }
                $user[0]->rememberme = $data['rememberme'];
                // return json_encode($user);
                return $user;
            }
        }
        return json_encode(array('error' => 'supplied parameters are invalid'));
    }

    /*
     * fn to convert image to base64
     * returns base64 string
     */

    public function imageToBase64($path) {
        $type = pathinfo($path, PATHINFO_EXTENSION);
        $data = file_get_contents($path);
        $base64 = 'data:image/' . $type . ';base64,' . base64_encode($data);
        return $base64;
    }

    /*
     * fn to upload the image
     * param are image and folder name.
     */

    public function uploadImage($image, $folder) {
        // print '<pre>';
        // print_r($image);
        // exit;
        //=== creating folder if not existing ==//
        if (!file_exists($folder)) {
            mkdir($folder, 0777, true);
        }
        // if (!file_exists($folder . '/thumb')) {
        //     mkdir($folder . '/thumb', 0777, true);
        // }
        //===================================//
        $myFile = $image;
        if ($myFile->getError() === UPLOAD_ERR_OK) {
            $uploadFileName = $myFile->getClientFilename();
            $imgName = $uploadFileName . '-' . date('Y-m-d H:i:s');
            $path = $folder . '/' . $imgName;
           // $destination = $folder . '/thumb/' . $imgName;
            $myFile->moveTo($path);
           // $thumbPath = $this->compress($path, $destination, 10);
            $pathArray = array(
                'path' => $path,
               // 'thumbPath' => $thumbPath,
            );
            return $pathArray;
        }
    }

    /*
     * fn to compress image
     */

    public function compress($source, $destination, $quality) {
        $info = getimagesize($source);
        if ($info['mime'] == 'image/jpeg')
            $image = imagecreatefromjpeg($source);

        elseif ($info['mime'] == 'image/gif')
            $image = imagecreatefromgif($source);

        elseif ($info['mime'] == 'image/png')
            $image = imagecreatefrompng($source);

        imagejpeg($image, $destination, $quality);
        return $destination;
    }

    /*
     * fn to check uniqueness of an element in a table.
     * param are table_name, column-name, value and id. 
     */

    public function checkUniquenessofElement($table, $column, $value, $id) {
        if (empty($id)) {
            $query = DB::select("select count(id) as count from " . $table . " where " . $column . " = '" . $value . "' ");
        } else {
            $query = DB::select("select count(id) as count from " . $table . " where " . $column . " = '" . $value . "' AND id != '" . $id . "' ");
        }
        if ($query[0]->count == 0) {
            return false; // not redundant
        } else {
            return true; // redundant data
        }
    }

    /*
     * fn to convert base64 to image
     */

    public function base64_to_jpeg($base64_string, $output_file, $folder) {
        if (!file_exists($folder)) {
            mkdir($folder, 0777, true);
        }
        $newFile = $folder . '/' . $output_file;
        $ifp = fopen($newFile, "wb");
        $data = explode(',', $base64_string);
        fwrite($ifp, base64_decode($data[1]));
        fclose($ifp);
        return( $output_file );
    }

    /*
     * fn to get entire data from a table
     * param is tablename
     */

    function entireData($table = null) {
        if (!empty($table)) {
            $query = DB::table($table)
                    ->select('*')
                    ->where('deleteStatus',1)
                    ->get();
            if (!empty($query)) {
                return $query;
            }
        }
        return array();
    }

    /*
     * fn to get entire data from a table
     * a condition need to be satisfied
     * param are tablename, columnname, columnvalue
     */

    function entireDatawithCondition($table = null, $key = null, $value = null) {
        if (!empty($table) && !empty($key) &&!empty($value)) {
            $query = DB::table($table)
                    ->select('*')
                    ->where($key,$value)
                    ->where('status',1)
                    ->where('deleteStatus',1)
                    ->get();
            if (!empty($query)) {
                return $query;
            }
        }
        return array();
    }

    /*
     * fn to get data of a particular range from a particular table
     * param are tablename,lastpage,perpage
     */

    function pageData($table = null, $prePage = null, $perPage = null) {
        $offset = $prePage * $perPage;
        if (!empty($table) && !empty($perPage)) {
            $query = DB::table($table)
                    ->select('*')
                    ->where('deleteStatus',1)
                    ->limit($perPage)->offset($offset)
                    ->orderBy('id','desc')
                    ->get();
            if (!empty($query)) {
                return $query;
            }
        }
        return array();
    }

    /*
     * fn to get data of a particular range from particular table
     * param are tablename, lastpage, perpage, condition
     */

    function pageDatawithCondition($table = null, $prePage = null, $perPage = null, $key = null, $value = null) {
        DB::enableQueryLog();
        $offset = $prePage * $perPage;
        if (!empty($table) && !empty($perPage) &&!empty($key) &&!empty($value)) {
            $query = DB::table($table)
                    ->select('*')
                    ->where($key,$value)
                    ->where('status',1)
                    ->where('deleteStatus',1)
                    ->limit($perPage)->offset($offset)
                    ->orderBy('id','desc')
                    ->get();
            if (!empty($query)) {
                return $query;
            }
        }
        return array();
    }

    /*
     * fn to findout total matches of a particular search
     * param are tablename, columnname, searchkeyword
     */

    function matchesFound($table = null, $column = null, $keyword = null) {
        if (!empty($table) && !empty($column)) {
            $query = DB::table($table)
                    ->select('*')
                    ->where('deleteStatus',1)
                    ->where($column, 'like', '%' . $keyword . '%')
                    ->get();
            if (!empty($query)) {
                return $query;
            }
        }
        return array();
    }
    /*
     * fn to toggle status
     * param are tablename, status, primary key value
     */

    function togglestatus($table = null, $status = null, $key = null) {
            $query = DB::table($table)
                    ->where('id', $key)
                    ->update(['status' => $status]);
            if (!empty($query)) {
                return $query;
            }
       
        return false;
    }
    /*
     * fn to toggle multi status
     * param are tablename, status, primary keys value
     */

    function togglestatusMulti($table = null, $status = null, $key = null) {
            $query = DB::table($table)
                    ->whereIn('id', $key)
                    ->update(['status' => $status]);
            if (!empty($query)) {
                return $query;
            }
       
        return false;
    }
    /*
     * fn to getDailyaudio
     * param are tablename, status, primary keys value
     */

    function getDailyaudio($date = null) {
            $query = DB::table('meditation')
                    ->where('date', $date)
                    ->get()
                    ->first();
            if (!empty($query)) {
                return $query;
            }else{
                $query = DB::table('meditation')
                    ->inRandomOrder()
                    ->get()
                    ->first();
            }
       
        return $query;
    }
    /*
     * fn to getQuote
     * param are tablename, status, primary keys value
     */

    function getQuote($date = null) {
                $query = DB::table('content')
                    ->where('content_type_id', 4)
                    ->inRandomOrder()
                    ->get()
                    ->first();
            
        return $query;
    }
    /*
     * fn to send mail
     * param are tablename, status, primary key value
     */

    function sendMail($mailer=null,$type = null, $email = null, $key = null,$value = null) {
            $message = (new Swift_Message('Subject'))
              ->setFrom(['nighil@hawkssolutions.com' => 'Nighil George'])
              ->setTo([$email])
              ->setBody('Send Body');
               // Send the message
            $result = $mailer->send($message);
              // Mail with template
            //  $message = Swift_Message::newInstance("$title")
            //     ->setFrom(array("$sender_email" => "$sender_name"))
            //     ->setTo(array("$email"))
            //     ->setBody($message_content,'text/html');
            // $message_content = $app->render('email.template.twig',array('name'=>'JustSteveKing', 'age'=>26));\
             // Send the message
            // $result = $mailer->send($message_content);
           
              if($result){
                return true;
              }else{
                return false;
              }
    }
    /*
     * fn to deleteimage 
     * param are tablename, primary key value,
     */

    function deleteimage($table = null, $key = null) {
            $query = DB::table($table)
                    ->where('id', $key)
                    ->update(['image' =>null]);
            if (!empty($query)) {
                return $query;
            }       
        return false;
    }
    /*
     * fn to delete 
     * param are tablename, primary key value,
     */

    function softdelete($table = null, $key = null,$value = null) {
            $query = DB::table($table)
                        ->when($value!=null, function($query) use ($key,$value) {
                           return  $query->where($key,$value); 
                        })
                        ->when($value==null, function($query) use ($key) {
                           return  $query->where('id',$key); 
                        })
                    ->update(['deleteStatus' =>0]);
            if (!empty($query)) {
                return $query;
            }
       
        return false;
    }
    /*
     * fn to delete multi items
     * param are tablename, array of primary key values,
     */

    function softdeleteMulti($table = null,$key = null,$value = null) {
            $query = DB::table($table)
                    ->when($value!=null, function($query) use ($key,$value) {
                           return  $query->where($key,$value); 
                        })
                        ->when($value==null, function($query) use ($key) {
                           return  $query->where('id',$key); 
                        })
                    ->update(['deleteStatus' =>0]);
            if (!empty($query)) {
                return $query;
            }
       
        return false;
    }
    /*
     * fn to get one row
     * param are tablename, primary key
     */

    function getrow($table = null,$field=null, $key = null) {
            $query = DB::table($table)
                    ->select('*')
                    ->where($field, $key)
                    ->get();
            if (!empty($query)) {
                return $query;
            }
       
        return false;
    }

    /*
     * fn to findout per page matches of a particulr search
     * param are tablename, previouspage, perpage, coulmnname, keyword
     */

    function resultperPage($table = null, $prePage = null, $perPage = null, $column = null, $keyword = null) {
        $offset = $prePage * $perPage;
        if (!empty($table) && !empty($perPage) && !empty($column)) {
            $query = DB::table($table)
                    ->select('*')
                    ->where('deleteStatus',1)
                    ->where($column, 'like', '%' . $keyword . '%')
                    ->limit($perPage)->offset($offset)
                    ->orderBy('id')
                    ->get();
            if (!empty($query)) {
                return $query;
            }
        }
        return array();
    }

}
